#include "processing/checkers/TraceInclusionChecker.hpp"
#include "sfsm/TransitionRelationGenerator.hpp"

namespace libfsmtest::SFSMs {

TraceInclusionChecker::TraceInclusionChecker(Sfsm const &paramSfsm)
 : sfsm(paramSfsm),
   currentStates({sfsm.getInitialStateId()})
{
}

bool TraceInclusionChecker::operator()(SymbolicTrace::value_type const &ioPair) {
    if(not this->currentStates.empty()) {
        this->currentStates = getTargetStatesForSfsm(this->sfsm, this->currentStates, {ioPair});
    }
    return not this->currentStates.empty();
}

}

