/*
 * Copyright 2022 Niklas Krafczyk, Jan Peleska
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is furnished to do
 * so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
#pragma once

#include <vector>
#include <string>
#include <utility>
#include <map>

namespace libfsmtest::SFSMs {
class Expression;
}

namespace libfsmtest::SFSMs {

typedef std::vector<Expression> Expressions;
typedef std::string Identifier;
typedef std::vector<Identifier> Identifiers;
typedef std::string Value;
class IdentifierType;
typedef std::pair<Identifier, IdentifierType> IdentifierDefinition;
typedef std::vector<IdentifierDefinition> IdentifierDefinitions;
typedef std::pair<IdentifierDefinition, Value> IdentifierValuation;
typedef std::vector<IdentifierValuation> IdentifierValuations;
typedef std::map<IdentifierDefinition, Value> ValuationFunction;

size_t combine_hashes(size_t previousHash, size_t hash);

}

